## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

Name:           kaidan
Version:        0.9.2
Release:        %autorelease
Summary:        A XMPP client based on KDE Framework

# https://invent.kde.org/network/kaidan/-/raw/master/LICENSE
# src/qml/elements/IconTopButton.qml files is under LGPL-2.0-or-later license for 0.9.1 release,
# which will be relicensed to GPL-3.0-or-later when new release is published.
# see: https://invent.kde.org/network/kaidan/-/commit/14c712eb72e7094d22f9faeec8a8a86effe72ade?page=2#c88f477dc2798d0fbde587cea39b54208314e23b
# https://bugzilla.redhat.com/show_bug.cgi?id=2216600#c16
License:        GPL-3.0-or-later AND MIT AND Apache-2.0 AND CC-BY-SA-4.0 AND LGPL-2.0-or-later
URL:            https://invent.kde.org/network/kaidan
Source0:        %{url}/-/archive/v%{version}/%{name}-v%{version}.tar.gz

# kquickimageeditor is actually a runtime dep, not used during the build,
# and the qt5 and qt6 builds use the same cmake package name.
Patch0:         kquickimageeditor-devel.patch

%if 0%{?fedora} || 0%{?epel} > 7
# handled by qt5-srpm-macros, which defines %%qt5_qtwebengine_arches
# Package doesn't build on arches that qtwebengine is not built on.
ExclusiveArch: %{qt5_qtwebengine_arches}
%endif

# https://fedoraproject.org/wiki/Changes/EncourageI686LeafRemoval
ExcludeArch: %{ix86}

BuildRequires:  gcc-c++
BuildRequires:  cmake
BuildRequires:  ninja-build
BuildRequires:  extra-cmake-modules

BuildRequires:  cmake(Qt5Core)
BuildRequires:  cmake(Qt5Concurrent)
BuildRequires:  cmake(Qt5Qml)
BuildRequires:  cmake(Qt5Quick)
BuildRequires:  cmake(Qt5Svg)
BuildRequires:  cmake(Qt5Sql)
BuildRequires:  cmake(Qt5QuickControls2)
BuildRequires:  cmake(Qt5Xml)
BuildRequires:  cmake(Qt5Multimedia)
BuildRequires:  cmake(Qt5Positioning)
BuildRequires:  cmake(Qt5Location)
BuildRequires:  cmake(Qt5LinguistTools)

BuildRequires:  cmake(KF5KIO)
BuildRequires:  cmake(KF5CoreAddons)
BuildRequires:  cmake(KF5Kirigami2)
#BuildRequires:  cmake(KQuickImageEditor)
BuildRequires:  cmake(KF5KirigamiAddons)
BuildRequires:  cmake(KF5Notifications)
BuildRequires:  kf5-rpm-macros
BuildRequires:  cmake(ZXing)
BuildRequires:  cmake(QXmpp)
# optional dependencies
BuildRequires:  cmake(KF5QQC2DesktopStyle)

BuildRequires:  desktop-file-utils
BuildRequires:  libappstream-glib

# src/hsluv-c directory
# https://github.com/hsluv/hsluv-c
Provides:       bundled(hsluv-c)
# src/singleapp directory
# https://github.com/itay-grudev/SingleApplication
Provides:       bundled(SingleApplication)

# QML module dependencies
Requires:       kf5-kirigami2%{?_isa}
Requires:       kf5-kirigami2-addons%{?_isa}
Requires:       kf5-kquickcharts%{?_isa}
Requires:       qt5-qtgraphicaleffects%{?_isa}
Requires:       qt5-qtquickcontrols2%{?_isa}
Requires:       qt5-qtwebchannel%{?_isa}
Requires:       qt5-qtwebengine%{?_isa}
Requires:       kquickimageeditor-qt5%{?_isa}
Requires:       hicolor-icon-theme

%description
Kaidan is a simple, user-friendly and modern chat client. It uses the open
communication protocol XMPP (Jabber). The user interface makes use of Kirigami
and QtQuick, while the back-end of Kaidan is entirely written in C++ using Qt
and the Qt-based XMPP library QXmpp.

%prep
%autosetup -p1 -n %{name}-v%{version}

%build
%cmake_kf5 \
    -GNinja \
    -DUSE_KNOTIFICATIONS=ON \
    -DBUILD_TESTING=ON \
    -DBUILD_TESTS=ON \

%cmake_build

%install
%cmake_install

%find_lang %{name} --with-qt

%check
# https://koji.fedoraproject.org/koji/taskinfo?taskID=102424233
# https://kojipkgs.fedoraproject.org/work/tasks/4248/102424248/build.log
%ctest -E 'PublicGroupChatTest'

desktop-file-validate %{buildroot}%{_datadir}/applications/im.kaidan.kaidan.desktop
appstream-util validate-relax --nonet %{buildroot}%{_metainfodir}/im.kaidan.kaidan.appdata.xml

%files -f %{name}.lang
%license LICENSE
%doc README.md
%{_bindir}/%{name}
%dir %{_datadir}/%{name}
%{_datadir}/applications/im.kaidan.kaidan.desktop
%{_metainfodir}/im.kaidan.kaidan.appdata.xml
%{_datadir}/icons/hicolor/128x128/apps/kaidan.png
%{_datadir}/icons/hicolor/scalable/apps/kaidan.svg
%{_datadir}/knotifications5/kaidan.notifyrc
%{_datadir}/%{name}/images
%{_datadir}/%{name}/providers.json

%changelog
## START: Generated by rpmautospec
* Fri Jul 26 2024 topazus <topazus@outlook.com> - 0.9.2-1
- 0.9.2

* Thu Jul 18 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.9.1-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Sun May 26 2024 topazus <topazus@outlook.com> - 0.9.1-9
- rebuild with qxmpp

* Wed Jan 24 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.9.1-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Sat Jan 20 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.9.1-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Mon Dec 11 2023 topazus <topazus@outlook.com> - 0.9.1-6
- fix runtime dependency name of kquickimageeditor; fix rhbz#2253555

* Wed Dec 06 2023 Yaakov Selkowitz <yselkowitz@fedoraproject.org> - 0.9.1-5
- Avoid build dependency on kquickimageeditor-devel

* Thu Jul 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.9.1-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Fri Jul 14 2023 topazus <topazus@outlook.com> - 0.9.1-3
- add runtime dependency kquickimageeditor

* Wed Jul 12 2023 topazus <topazus@outlook.com> - 0.9.1-2
- fix license; mark bundled libraries

* Mon Jul 10 2023 topazus <topazus@outlook.com> - 0.9.1-1
- initial import; RHBZ#2216600
## END: Generated by rpmautospec
